/****************************************************************************
** $Id: qt/examples/qdir/qdir.cpp   2.2.3   edited 2000-08-31 $
**
** Copyright (C) 1992-2000 Trolltech AS.  All rights reserved.
**
** This file is part of an example program for Qt.  This example
** program may be used, distributed and modified without limitation.
**
*****************************************************************************/
#include <qapplication.h>
#include <qbutton.h>
#include <qobjectlist.h>
#include <qfiledialog.h>
#include <qregexp.h>
#include <stdlib.h>

int main( int argc, char ** argv )
{
    QApplication qdir_app( argc, argv );
    QFileDialog  *fd   = new QFileDialog( 0, "LVE_FileDialog", TRUE );
    QString      start = QDir::currentDirPath();
    QString      ext   = "";
    
    if (!fd) return 1;

    if (argc >= 2) 
    {
      QString           caption = "LVE file selector - ";
      QString           bt_text = argv[1];
      QFileDialog::Mode mode;
      const QObjectList *ol  = NULL;

      if (!strcmp("new", argv[1])) 
      {
        mode = QFileDialog::AnyFile;
        caption += "new/open";
        bt_text = "Ok";
      }
      else if (!strcmp("open", argv[1])) 
      {
        mode = QFileDialog::ExistingFile;
        caption += argv[1];
      }
      else if (!strcmp("save", argv[1])) 
      {
        mode = QFileDialog::AnyFile;
        caption += argv[1];
      }
      
      fd->setMode( mode );
      fd->setCaption( caption );
  
      ol = fd->children();    
      if (ol)
      { 
        QObjectListIt it(*ol);
        QObject       *obj;

        while ( (obj = it.current()) != 0 ) 
        {
          ++it;
          if ( !strcmp(obj->className(), "QPushButton") && 
               !strcmp(obj->name(),"OK") )
            ((QButton*)obj)->setText( bt_text );
        }
      }

      //-- reminded start folder --
      if (argc >= 3) start = argv[2];
    
      //-- extension filters --
      if (argc >= 4) 
      {
        QString filters;
        
        switch (atoi(argv[3]))
        {
          case 0:
            filters += 
              "MPEG files(*.vob;*.VOB;*.mpg;*.MPG;*.mpeg;*.MPEG;*.m2v;*.M2V;*.m1v;*.M1V;*.idx;*.IDX);;";
            break;
          
          case 1:
            filters += 
              "Media lists (*.lst);;";
            ext = ".lst";
            break;

          case 2:
            filters += 
              "LVE projects (*.prj);;";
            ext = ".prj";
            break;
        }
        filters += "All files (*)";

        fd->setFilters(filters);
      }
    }

    fd->setSelection( start );

    if ( fd->exec() == QDialog::Accepted ) 
    {
      QString result = fd->selectedFile();
     
      
      if (!QFile::exists(result))
      { 
        if ( !strrchr((const char *)result, '.') ) result += ext; 
      }
     
       printf("\"%s\"\n", (const char*)result);
      
      delete fd;
      return 0;
    } 

    delete fd;
    return 1;
}
